import ICommand from '../Interfaces/ICommand';
import { Message, Collection } from 'discord.js';
declare abstract class Command implements ICommand {
    AllowedChannels: string[];
    AllowedRoles: string[];
    AllowedUsers: string[];
    Data: any;
    RequiresDatabase: boolean;
    Signature: string;
    private Modified;
    constructor(channels: string[], roles: string[], users: string[], dbRequired?: boolean);
    LocalData: any;
    readonly HasLocalData: boolean;
    abstract Run(message: Message): Promise<any>;
    abstract Name(): string;
    abstract Namespace(): string;
    private HasLocalField;
    protected ValidateChannel(channelId: string): boolean;
    protected ValidateRoles(roles: Collection<any, any>): boolean;
    protected ValidateUsers(user: string): boolean;
    private GetValidationPermission;
    private ModifyPermissions;
    AddAllowedChannel(channelId: string, local?: boolean): void;
    AddAllowedRole(roleId: string, local?: boolean): void;
    AddAllowedUser(user: string, local?: boolean): void;
    Call(message: Message): Promise<any>;
    GetContext(message: Message): any;
    RemoveAllowedChannel(channelId: string, local?: boolean): void;
    RemoveAllowedRole(roleId: string, local?: boolean): void;
    RemoveAllowedUsers(user: string, local?: boolean): void;
    Save(): Promise<any>;
}
export default Command;
//# sourceMappingURL=Command.d.ts.map