"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Command_1 = __importDefault(require("../../Abstractions/Command"));
class StreamLeader extends Command_1.default {
    constructor(channels, roles, users, dbRequired = false) {
        super(channels, StreamLeader.ROLES, users, dbRequired);
        console.log('StreamLeader Ignoring:', roles);
    }
    Name() {
        return 'StreamLeader';
    }
    Namespace() {
        return 'StreamTeam';
    }
    async AddDiscordRole(message, id) {
        const guild = message.guild;
        const member = guild.members.find((member) => member.id === id);
        if (!member.roles.has(StreamLeader.ROLE)) {
            member.addRole(StreamLeader.ROLE, `Added by ${message.author.username}`);
        }
    }
    async RemoveDiscordRole(message, id) {
        const guild = message.guild;
        const member = guild.members.find((member) => member.id === id);
        if (member.roles.has(StreamLeader.ROLE)) {
            return member.removeRole(StreamLeader.ROLE, `Removed by ${message.author.username}`);
        }
    }
    async Run(message) {
        const context = this.GetContext(message);
        const parameter = context.args[1].replace(/\D/g, '');
        switch ((context.args[0] || '').toLowerCase()) {
            case 'add':
                await Promise.all([
                    this.AddAllowedUser(parameter),
                    this.AddDiscordRole(message, parameter)
                ]);
                break;
            case 'delete':
                await Promise.all([
                    this.RemoveAllowedUsers(context.args[1]),
                    this.RemoveDiscordRole(message, parameter)
                ]);
                break;
            default:
                return message.channel.send(`Invalid Argument: ${context.args[0]}`);
        }
        return message.channel.send('Records Updated');
    }
}
StreamLeader.NAME = 'StreamLeader';
StreamLeader.ROLE = '509747336990162945';
StreamLeader.ROLES = [
    '298481589506015232',
    '298481229316227073'
];
exports.default = StreamLeader;
