"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const mongoose_1 = __importDefault(require("mongoose"));
const Users_1 = __importDefault(require("../Database/Models/Users"));
const Commands_1 = __importDefault(require("../Database/Models/Commands"));
const State_1 = __importDefault(require("../Models/State"));
class Context {
    constructor(client) {
        this.Loading = true;
        this.Client = client;
    }
    Initialize(dbString) {
        const conString = dbString || process.env.CONNECTION_STRING;
        if (!conString || conString.length === 0) {
            this.Loading = false;
            console.log('[MISS] No Datbase provided');
            return Promise.resolve(false);
        }
        return mongoose_1.default
            .connect(dbString || process.env.CONNECTION_STRING)
            .then(async () => {
            const users = await Users_1.default.find();
            const commands = await Commands_1.default.find();
            const usersState = {};
            const commandsState = {};
            users.forEach((user) => {
                usersState[user.Name] = user;
            });
            commands.forEach((command) => {
                commandsState[command.Namespace] = command;
            });
            this.State = new State_1.default(commandsState, usersState);
            this.Loading = false;
            return this.Loading;
        })
            .then(() => {
            console.log('[SUCCESS] Database Loaded');
            return Promise.resolve(true);
        })
            .catch((e) => {
            console.error('[ERROR] Database Failed to Load', e);
        });
    }
    async Save() {
    }
}
exports.default = Context;
