"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const discord_js_1 = require("discord.js");
const Context_1 = __importDefault(require("./Services/Context"));
const Processor_1 = __importDefault(require("./Services/Processor"));
const dotenv_1 = __importDefault(require("dotenv"));
// load environment
dotenv_1.default.config();
class Aidyn {
    constructor(dbString, botToken, prefix = '%') {
        this.Client = new discord_js_1.Client();
        this.Loaded = false;
        this.Context = new Context_1.default(this.Client);
        this.BotToken = botToken;
        this.Processor = new Processor_1.default(this.Context, prefix);
        this.ConnectionString = dbString;
    }
    async LoadCommands(commands) {
        const useDB = await this.Context.Initialize(this.ConnectionString);
        const results = await this.Processor.LoadCommands(commands, useDB);
        this.Loaded = true;
        return results;
    }
    async Start(commands) {
        if (this.Loaded === false && !commands) {
            throw new Error("No Commands Loaded!");
        }
        else if (this.Loaded === false && commands) {
            await this.LoadCommands(commands);
        }
        const { Client, Processor, BotToken } = this;
        Client.on('message', Processor.Handle);
        Client
            .login(BotToken || process.env.BOT_TOKEN)
            .then(() => {
            console.log('[SUCCESS] Bot Online');
        });
    }
}
exports.default = Aidyn;
